#include <Pilot.h>

#include "trans.h"
#include "globals.h"

DmOpenRef cacheDB;
DmOpenRef cacheInfoDB;
DmOpenRef hotlistDB;
DmOpenRef storageDB;
DmOpenRef historyDB;
DmOpenRef offlineDB;
DmOpenRef offlineInfoDB;


ConID conID;           /* connection id for network subsystem */
VoidHand hPage;        /* handle to the current page */
WinHandle disp;        /* handle to the display window */
Word dispError;        /* error for window, needed to create window */
int currYPosOffset;    /* scrolling position for the page */
int currXPosOffset;    /* scrolling position for the page */
int lastLayoutYExtent; /* a trick to maybe get scroll limit working */
int penDownOrigPieceOff;    /* original pen down location */
SWord penDownOrigImageFlag; /* image save of pen down piece */
VoidHand hProxyServer;
char proxyServer[64];
int proxyPort;
char fallbackServer[64];
int fallbackPort;
int currRequestID;     /* data to allow dropping of old data */
int firstOpen;         /* redirects cancel back to splash on first instance */
ChunkHand curChunk;
VoidHand curURL;
Word curURLLength;
VoidHand transURL;
Word transURLLength;
int curHistory;
int tcurHistory;
Int curTop;

Boolean remap;
Int scrollSize;
Int histSize;
ULong cacheSize;
DWord version;

void SetGlobals() {
  version = PROTOCOL_VERSION;
  conID = -1;
  hPage = NULL;
  disp = 0;
  dispError = 0;
  currYPosOffset = 0;
  currXPosOffset = 0;
  lastLayoutYExtent = 0;
  penDownOrigPieceOff = -1; 
  penDownOrigImageFlag = 0; 

  currRequestID = 0;
  curChunk = NULL;
  curURL = NULL;
  curURLLength = 0;
  transURL = NULL;
  transURLLength = 0;
  curHistory = -1;
  tcurHistory = -1;
  curTop = 0;

  remap = DEF_REMAP_VAL;
  scrollSize = DEF_SCROLL_VAL;
  histSize = DEF_HIST_VAL;
  cacheSize = DEF_CACHE_VAL;
  StrCopy(proxyServer, DEF_PROXY_IP);
  proxyPort = DEF_PROXY_PORT;

  fallbackServer[0] = 0;
  fallbackPort = 0;

  firstOpen = 1;
}

