#include <Pilot.h>
#include "globals.h"
#include "2bit.h"
#include "callback.h"

static int drawnform = 0;

static void showbitmap(void)
{
    BitmapPtr bmp;
    VoidHand hBmp;

    hBmp = DmGetResource('Tbmp', 2222);
    if (!hBmp) return;
    bmp = MemHandleLock(hBmp);
    if (bmp) {
	WinDraw2Bitmap(bmp, 80, 90);
	MemHandleUnlock(hBmp);
    }
    DmReleaseResource(hBmp);
    WinDrawLine(0,139,155,139);
}

Boolean SplashFormHandleEvent (EventPtr e) {
  Boolean handled = false;
  FormPtr frm;
  
  CALLBACK_PROLOGUE

  switch (e->eType) {
  case frmOpenEvent:
    frm = FrmGetActiveForm();
    FrmCopyLabel(frm, SplashVersLabel, "Version " TITLE_VERSION);
    FrmDrawForm(frm);
    drawnform = 1;
    showbitmap();
    /* FrmSetFocus(frm, FrmGetObjectIndex(frm, URLFormFld)); */
    handled = true;
    break;
    
  case menuEvent:
    MenuEraseStatus(NULL);

    switch(e->data.menu.itemID) {
    case GetMenu:
	FrmGotoForm(URLForm);
	break;

    case PrefsMenu:
	FrmGotoForm(PrefsForm);
	break;
    }
    handled = true;
    break;
    
  case keyDownEvent:
    /* null */
    break;
    
  case ctlSelectEvent:
    switch(e->data.ctlEnter.controlID) {
    case SplashLoad:
      FrmGotoForm(URLForm);
      handled = true;
      break;

    case SplashOff:
      firstOpen = 0;
      FrmGotoForm(MainForm); 
      handled = true;
      break;
      
    case SplashWare:
      frm = FrmInitForm(WareForm);
      FrmDoDialog(frm);
      FrmDeleteForm(frm);
      handled = true;
      break;

    default:
      break;
    }
    break;
    
  case winEnterEvent:
    /* Refresh the screen if necessary */
    if (e->data.winEnter.enterWindow == FrmGetWindowHandle(FrmGetActiveForm())
	&& e->data.winEnter.enterWindow != e->data.winEnter.exitWindow) {
	if (drawnform) showbitmap();
    }
    break;

  default:
    break;
    
  }

  CALLBACK_EPILOGUE

  return handled;
}
